// HexRead.cpp : Defines the entry point for the console application.
//	Reads in a file that uses Intel's HEX format and 
//  spits out everything that it finds. Basically, er, this is a proof-of-concept
//  application.
//

#include "stdafx.h"
#include "picops.h"


int main(int argc, char* argv[])
{
	int i, iCount;
	int chIn, iRecSize, iLoadAddr;
	int iType, iChecksum, iSum;
	char bytes[256];	// For now..I think this is probably always enough. (and in fact, it is)
	char szByte[3];
	char szBuf[1024];
	FILE* pFile;
	INSTR instr;

	instr.word = POP;

	// Bah, this is bad...
	pFile = fopen("P1.HEX", "r");

	iCount = 0;
	while((chIn = getc(pFile)) != EOF) {
		if(chIn == ':') {
			iCount++;
			// We've reached the start of a record, sooo...get the fields.
			// Data record size
			if(fgets(szBuf, 3, pFile) != NULL) {
				sscanf(szBuf, "%x", &iRecSize);
			}
			else {
				puts("Unable to get record size.");
				return EXIT_FAILURE;
			}

			// Load address
			if(fgets(szBuf, 5, pFile) != NULL) {
				sscanf(szBuf, "%x", &iLoadAddr);
			}
			else {
				puts("Unable to get load address.");
				return EXIT_FAILURE;
			}

			// Record type
			if(fgets(szBuf, 3, pFile) != NULL) {
				sscanf(szBuf, "%x", &iType);
			}
			else {
				puts("Unable to get record type.");
				return EXIT_FAILURE;
			}

			// Data record
			if(fgets(szBuf, 2*iRecSize+1, pFile) != NULL) {
				// Yeah..we have to munge the bloody things back together, feh..
				szByte[2] = '\0';
				for(i = 0; i < 2*iRecSize; i += 2) {
					szByte[0] = szBuf[i];
					szByte[1] = szBuf[i+1];
					sscanf(szByte, "%x", &bytes[i/2]);
				}
			}
			else {
				puts("Failure in reading data record.");
				return EXIT_FAILURE;
			}

			// Checksum
			if(fgets(szBuf, 3, pFile) != NULL) {
				sscanf(szBuf, "%x", &iChecksum);
			}
			else {
				puts("Unable to read checksum.");
				return EXIT_FAILURE;
			}

			// Okay, now that the record is read, we need to check to see if we didn't get
			// a checksum failure.
			iSum = iRecSize + iLoadAddr + iType + iChecksum;
			for(i = 0; i < iRecSize; i++) {
				iSum += bytes[i];
			}
			if((iSum & 0xFF) != 0x00) {
				// Dammit!
				printf("Checksum error at record %d!\n", iCount);
			}
			else {
				// Print out all the fields, just for confirmation.
				printf("Record %d:\n"
					"\tSize = %d\n"
					"\tLoad Address = %0#6x\n"
					"\tType = ", iCount, iRecSize, iLoadAddr);
				switch(iType) {
				case 0:
					printf("Data (00h)\n");
					break;
				case 1:
					printf("End of File (01h)\n");
					break;
				case 2:
					printf("Extended Segment Address (02h)\n");
					break;
				case 3:
					printf("Start Segment Address (03h)\n");
					break;
				case 4:
					printf("Extended Linear Address (04h)\n");
					break;
				case 5:
					printf("Start Linear Address (05h)\n");
					break;
				default:
					printf("Unknown record type\n");
					break;
				}

				// Checksum and data o/~
				printf("\tChecksum = %0#4x\n"
					   "\tData =\n\t", iChecksum);

				for(i = 0; i < iRecSize; i++) {
					printf("%03.2hx ", 0xff & bytes[i]);
					if(i % 4 == 0 && i) {
						printf("\n\t");
					}
				}
				printf("\n");
			}
		}
	}

	return EXIT_SUCCESS;
}